"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Memoize = void 0;
var Memoize = function () {
    return function (target, key, descriptor) {
        var fn = descriptor === null || descriptor === void 0 ? void 0 : descriptor.value;
        var cache = {};
        descriptor.value = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var argumentTaken = args[0];
            if (argumentTaken in cache) {
                return cache[argumentTaken];
            }
            else {
                var result = fn(argumentTaken);
                cache[argumentTaken] = result;
                return result;
            }
        };
        return descriptor;
    };
};
exports.Memoize = Memoize;
